//
// ~쐬
//
// written by T.Noda
//
//  2001/06/26 Ver 0.0.1 ~
//  2001/06/29 Ver 0.0.2 OA~
//
// D1:㕔a D2:a H:
//
//************************************
//
//  CvO
//
//************************************
Program CONE;
var
  D1, D2, H, A, B, C, r1, r2, x0, y0, x1, y1, x2, y2, xm, ym : double;

Begin
  AddImage(20, 20, 'CONE_PARAM.BMP');

  AddLabel(130, 20, 95, 13, '㕔a(D1)');
  AddLabel(130, 50, 95, 13, 'a(D2)');
  AddLabel(130, 80, 95, 13, '(H)');

  AddEdit(1, 230, 20, 50, 21, '');
  AddEdit(2, 230, 50, 50, 21, '');
  AddEdit(3, 230, 80, 50, 21, '');

  If ShowDlg(300, 180,'~}_CAO') <> True Then
    Exit;

  D1 := StrToFloat(GetDlgText(1)); // ɕϊ
  D2 := StrToFloat(GetDlgText(2));
  H := StrToFloat(GetDlgText(3));
  Message('zuʒu͂ĉB');
  if GetPos(xm, ym) = false then
  begin
    exit;
  end;
  LineType(0);  // 
  PenNo(1);     // yԍ
  if H = 0.0 then // O
  begin
    Circle(xm, ym, 0.5*D1);
    Circle(xm, ym, 0.5*D2);
    exit;
  end;
  if D1 = D2 then // ~
  begin
    x1 := xm-0.5*D1*Pi;
    y1 := ym;
    x2 := x1+D1*Pi;
    y2 := y1+H;
    Line(x1, y1, x1, y2);
    Line(x1, y2, x2, y2);
    Line(x2, y2, x2, y1);
    Line(x2, y1, x1, y1);
    exit;
  end;
  r1 := D1/(2.0*cos(ArcTan(2.0*H/(D2-D1))));
  r2 := D2/(2.0*cos(ArcTan(2.0*H/(D2-D1))));
  C := 180.0*D2/r2;
  A := 0.5*(180.0-C);
  B := A+C;
  x0 := xm;
  y0 := ym-r1*cos(0.5*C);
  Arc(x0, y0, r1, A, B);
  Arc(x0, y0, r2, A, B);
  x1 := x0+r1*cos(A);
  y1 := y0+r1*sin(A);
  x2 := x0+r2*cos(A);
  y2 := y0+r2*sin(A);
  Line(x1, y1, x2, y2);
  x1 := x0+r1*cos(B);
  y1 := y0+r1*sin(B);
  x2 := x0+r2*cos(B);
  y2 := y0+r2*sin(B);
  Line(x1, y1, x2, y2);
End.
